// This is a personal academic project. Dear PVS-Studio, please check it.
// PVS-Studio Static Code Analyzer for C, C++ and C#: http://www.viva64.com
#include "../include/server.h"

int main(int argc, char *argv[]) {
    int fd = createSocket();
    setSockOptions(fd);

    struct sockaddr_in address;
    setSockAddress(argc, argv, &address, INADDR_ANY);
    int fdAux = bindAndGetSocket(fd, &address);

    if (setvbuf(stdout, NULL, _IONBF, 0) != 0)
        printSystemError("Server: setvbuf()");

    startChallenge(fdAux);

    closeSocket(fd);
    return EXIT_SUCCESS;
}

void startChallenge(int fd) {
    FILE * stream;
    if ((stream = fdopen(fd, "r")) == NULL)
        printSystemError("Server: fdopen()");
    
    int challengeCount = 0;
    char * output = NULL;

    while (challengeCount < MAX_CHALLENGES) {
        challenge_t currentChallenge = challenges[challengeCount];
        printf("\033[1;1H\033[2J");
        if (genChallenge(stream, &output, currentChallenge)) {
            challengeCount++;
        }
        else {
            printf("Respuesta incorrecta: %s\n", output);
            sleep(TIME_SLEEP);
        }
        free(output);
    }

    printf("\033[1;1H\033[2J");
    printf("Felicitaciones, finalizaron el juego. Ahora deberán implementar el servidor que se comporte como el servidor provisto\n");

    if (stream != NULL) {
        if (fclose(stream) == EOF)
            printSystemError("Server: fclose()");
    }

    return;
}
